import { CodeAnalyzerConfigFactory } from '../factories/CodeAnalyzerConfigFactory';
import { EnginePluginsFactory } from '../factories/EnginePluginsFactory';
import { ConfigWriter } from '../writers/ConfigWriter';
import { ConfigViewer } from '../viewers/ConfigViewer';
import { LogEventListener } from '../listeners/LogEventListener';
import { ProgressEventListener } from '../listeners/ProgressEventListener';
import { ConfigActionSummaryViewer } from '../viewers/ActionSummaryViewer';
import { ConfigModelGeneratorFunction } from '../models/ConfigModel';
export type ConfigDependencies = {
    configFactory: CodeAnalyzerConfigFactory;
    pluginsFactory: EnginePluginsFactory;
    modelGenerator: ConfigModelGeneratorFunction;
    logEventListeners: LogEventListener[];
    progressEventListeners: ProgressEventListener[];
    writer?: ConfigWriter;
    actionSummaryViewer: ConfigActionSummaryViewer;
    viewer: ConfigViewer;
};
export type ConfigInput = {
    'config-file'?: string;
    'output-file'?: string;
    'rule-selector': string[];
    workspace?: string[];
};
export declare class ConfigAction {
    private readonly dependencies;
    private constructor();
    execute(input: ConfigInput): Promise<void>;
    static createAction(dependencies: ConfigDependencies): ConfigAction;
}
