"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BundleName = void 0;
exports.getMessage = getMessage;
exports.getMessages = getMessages;
const core_1 = require("@salesforce/core");
// Initialize Messages with the current plugin directory
core_1.Messages.importMessagesDirectory(__dirname);
var BundleName;
(function (BundleName) {
    BundleName["ActionSummaryViewer"] = "action-summary-viewer";
    BundleName["ConfigCommand"] = "config-command";
    BundleName["ConfigModel"] = "config-model";
    BundleName["ConfigWriter"] = "config-writer";
    BundleName["PathStartUtil"] = "path-start-util";
    BundleName["ProgressEventListener"] = "progress-event-listener";
    BundleName["ResultsViewer"] = "results-viewer";
    BundleName["RuleViewer"] = "rule-viewer";
    BundleName["RulesCommand"] = "rules-command";
    BundleName["ResultsWriter"] = "results-writer";
    BundleName["RunAction"] = "run-action";
    BundleName["RunCommand"] = "run-command";
    BundleName["RunSummaryViewer"] = "run-summary-viewer";
    BundleName["Shared"] = "shared";
    BundleName["WorkspaceUtil"] = "workspace-util";
})(BundleName || (exports.BundleName = BundleName = {}));
class MessageCatalog {
    bundleMap = new Map();
    getMessage(bundle, messageKey, tokens) {
        return this.getBundle(bundle).getMessage(messageKey, tokens);
    }
    getMessages(bundle, messageKey, tokens) {
        return this.getBundle(bundle).getMessages(messageKey, tokens);
    }
    getBundle(bundle) {
        if (!this.bundleMap.has(bundle)) {
            this.bundleMap.set(bundle, core_1.Messages.loadMessages('@salesforce/plugin-code-analyzer', bundle.toString()));
        }
        // @ts-expect-error Map.get() can technically return undefined, but that will never happen in practice.
        return this.bundleMap.get(bundle);
    }
}
let INSTANCE;
function getMessage(bundle, messageKey, tokens) {
    INSTANCE = INSTANCE || new MessageCatalog();
    return INSTANCE.getMessage(bundle, messageKey, tokens);
}
function getMessages(bundle, messageKey, tokens) {
    INSTANCE = INSTANCE || new MessageCatalog();
    return INSTANCE.getMessages(bundle, messageKey, tokens);
}
//# sourceMappingURL=messages.js.map