import { CodeAnalyzer, CodeAnalyzerConfig, RuleSelection } from '@salesforce/code-analyzer-core';
export declare enum OutputFormat {
    RAW_YAML = "RAW_YAML",
    STYLED_YAML = "STYLED_YAML"
}
export interface ConfigModel {
    toFormattedOutput(format: OutputFormat): string;
}
export type ConfigContext = {
    config: CodeAnalyzerConfig;
    core: CodeAnalyzer;
    rules: RuleSelection;
};
export type ConfigModelGeneratorFunction = (relevantEngines: Set<string>, userContext: ConfigContext, defaultContext: ConfigContext) => ConfigModel;
export declare class AnnotatedConfigModel implements ConfigModel {
    private readonly relevantEngines;
    private readonly userContext;
    private readonly defaultContext;
    private constructor();
    toFormattedOutput(format: OutputFormat): string;
    static fromSelection(relevantEngines: Set<string>, userContext: ConfigContext, defaultContext: ConfigContext): AnnotatedConfigModel;
}
