"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPathStarts = createPathStarts;
const node_path_1 = __importDefault(require("node:path"));
const fg = __importStar(require("fast-glob"));
const messages_1 = require("../messages");
async function createPathStarts(pathStarts) {
    if (pathStarts == null) {
        return pathStarts;
    }
    const processedPaths = [];
    for (const pathStart of pathStarts) {
        // Negative globs are not currently supported.
        if (pathStart.includes("!")) {
            throw new Error((0, messages_1.getMessage)(messages_1.BundleName.PathStartUtil, 'error.negative-globs-unsupported', [pathStart]));
            // If the path a star (*) or question mark in it, we assume it's a glob.
        }
        else if (/[*?]/.test(pathStart)) {
            // For the convenience of Windows users, we'll normalize glob paths into UNIX style, so they're valid globs.
            const normalizedPathStart = pathStart.replace(/[\\/]/g, '/');
            // Globs and method-level targeting are mutually exclusive.
            if (node_path_1.default.basename(pathStart).includes('#')) {
                throw new Error((0, messages_1.getMessage)(messages_1.BundleName.PathStartUtil, 'error.glob-method-conflict', [pathStart]));
            }
            // Since Glob results are UNIX-styled, we need to convert the results to use whatever the local path separator
            // character is.
            processedPaths.push(...(await fg.glob(normalizedPathStart)).map(p => p.replace(/[\\/]/g, node_path_1.default.sep)));
        }
        else {
            processedPaths.push(pathStart);
        }
    }
    return processedPaths;
}
//# sourceMappingURL=PathStartUtil.js.map