"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toStyledHeaderAndBody = toStyledHeaderAndBody;
exports.toStyledHeader = toStyledHeader;
exports.makeGrey = makeGrey;
exports.toStyledPropertyList = toStyledPropertyList;
exports.indent = indent;
const ansis_1 = __importDefault(require("ansis"));
function toStyledHeaderAndBody(header, body, keys) {
    const styledHeader = toStyledHeader(header);
    const styledBody = indent(toStyledPropertyList(body, keys));
    return `${styledHeader}\n${styledBody}`;
}
function toStyledHeader(header) {
    return `${ansis_1.default.dim('===')} ${ansis_1.default.bold(header)}`;
}
function makeGrey(str) {
    return ansis_1.default.dim(str);
}
function toStyledPropertyList(body, selectedKeys) {
    if (body == null || (selectedKeys && selectedKeys.length === 0)) {
        return '';
    }
    const keysToPrint = selectedKeys || [...Object.keys(body)];
    const longestKeyLength = Math.max(...keysToPrint.map(k => k.length));
    const styleProperty = (key, value) => {
        const keyPortion = `${ansis_1.default.blue(key)}:`;
        const keyValueGap = ' '.repeat(longestKeyLength - key.length + 1);
        const valuePortion = value.replace('\n', `\n${' '.repeat(longestKeyLength + 2)}`);
        return `${keyPortion}${keyValueGap}${valuePortion}`;
    };
    const output = keysToPrint.map(key => styleProperty(key, body[key] || ''));
    return output.join('\n');
}
function indent(text, indentLength = 4) {
    return text.replace(/^.+/gm, m => m.length > 0 ? ' '.repeat(indentLength) + m : m);
}
//# sourceMappingURL=StylingUtil.js.map