"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWorkspace = createWorkspace;
const fg = __importStar(require("fast-glob"));
const messages_1 = require("../messages");
async function createWorkspace(core, workspacePaths) {
    const processedPaths = [];
    for (const workspacePath of workspacePaths) {
        // Negative globs are not currently supported.
        if (workspacePath.includes("!")) {
            throw new Error((0, messages_1.getMessage)(messages_1.BundleName.WorkspaceUtil, 'error.negative-globs-unsupported', [workspacePath]));
            // If the path has a star (*) or question mark in it, we assume it's a glob.
        }
        else if (/[*?]/.test(workspacePath)) {
            // For the convenience of Windows users, we'll normalize glob paths into UNIX style, so they're valid globs.
            const normalizedWorkspacePath = workspacePath.replace(/[\\/]/g, '/');
            // NOTE: We're pushing the strict results of the Glob, meaning that the paths will be normalized to UNIX style.
            processedPaths.push(...await fg.glob(normalizedWorkspacePath));
        }
        else {
            processedPaths.push(workspacePath);
        }
    }
    // Part of the contract for Core's `createWorkspace()` method is that paths are localized to the current OS, hence
    // it's not a problem for Glob results to be UNIX-formatted since they'll be converted right back.
    return core.createWorkspace(processedPaths);
}
//# sourceMappingURL=WorkspaceUtil.js.map