"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigActionSummaryViewer = void 0;
const StylingUtil_1 = require("../utils/StylingUtil");
const messages_1 = require("../messages");
class AbstractActionSummaryViewer {
    display;
    constructor(display) {
        this.display = display;
    }
    displaySummaryHeader() {
        this.display.displayLog((0, StylingUtil_1.toStyledHeader)((0, messages_1.getMessage)(messages_1.BundleName.ActionSummaryViewer, 'common.summary-header')));
    }
    displayLineSeparator() {
        this.display.displayLog("");
    }
    displayLogFileInfo(logFile) {
        this.display.displayLog((0, messages_1.getMessage)(messages_1.BundleName.ActionSummaryViewer, 'common.logfile-location'));
        this.display.displayLog((0, StylingUtil_1.indent)(logFile));
    }
}
class ConfigActionSummaryViewer extends AbstractActionSummaryViewer {
    constructor(display) {
        super(display);
    }
    view(logFile, outfile) {
        this.displaySummaryHeader();
        this.displayLineSeparator();
        if (outfile) {
            this.displayOutfile(outfile);
        }
        else {
            this.display.displayLog((0, messages_1.getMessage)(messages_1.BundleName.ActionSummaryViewer, 'config-action.no-outfiles'));
        }
        this.displayLineSeparator();
        this.displayLogFileInfo(logFile);
    }
    displayOutfile(outfile) {
        this.display.displayLog((0, messages_1.getMessage)(messages_1.BundleName.ActionSummaryViewer, 'config-action.outfile-location'));
        this.display.displayLog((0, StylingUtil_1.indent)(outfile));
    }
}
exports.ConfigActionSummaryViewer = ConfigActionSummaryViewer;
//# sourceMappingURL=ActionSummaryViewer.js.map