import { CodeAnalyzerConfig } from '@salesforce/code-analyzer-core';
export interface LogWriter {
    writeToLog(message: string): void;
    getLogDestination(): string;
    closeLog(): void;
}
export declare class LogFileWriter implements LogWriter {
    private readonly writeStream;
    private readonly destination;
    private constructor();
    writeToLog(message: string): void;
    getLogDestination(): string;
    closeLog(): void;
    static fromConfig(config: CodeAnalyzerConfig): Promise<LogFileWriter>;
}
