"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogFileWriter = void 0;
const path = __importStar(require("node:path"));
const fs = __importStar(require("node:fs/promises"));
class LogFileWriter {
    writeStream;
    destination;
    constructor(writeStream, destination) {
        this.writeStream = writeStream;
        this.destination = destination;
    }
    writeToLog(message) {
        this.writeStream.write(message);
    }
    getLogDestination() {
        return this.destination;
    }
    closeLog() {
        this.writeStream.end();
    }
    static async fromConfig(config) {
        const logFolder = config.getLogFolder();
        // Use the current timestamp to make sure each transaction has a unique logfile. If we want to reuse logfiles,
        // or just have one running logfile, we can change this.
        const logFile = path.join(logFolder, `sfca-${Date.now()}.log`);
        // 'w' flag causes the file to be created if it doesn't already exist.
        const fh = await fs.open(logFile, 'w');
        return new LogFileWriter(fh.createWriteStream({}), logFile);
    }
}
exports.LogFileWriter = LogFileWriter;
//# sourceMappingURL=LogWriter.js.map